var config = {
  extends: "eslint:recommended",
  parser: "babel-eslint",

  ecmaFeatures: {
    "jsx": true,
    "modules": true
  },
  env: {
    "browser": true,
    "es6": true,
    "node": true
  },
  rules: {
    "array-bracket-spacing": [2, "never"],
    "arrow-spacing": 2,
    "block-scoped-var": 2,
    "block-spacing": [2, "always"],
    "brace-style": [2, "1tbs"],
    "camelcase": [2, { "properties": "always" }],
    "comma-dangle": [2, "never"],
    "comma-spacing": [2, { "after": true, "before": false }],
    "comma-style": [2, "last"],
    "complexity": [2, 2],
    "computed-property-spacing": [2, "never"],
    "consistent-this": [2, "self"],
    "consistent-return": 2,
    "constructor-super": 2,
    "curly": 2,
    "default-case": 2,
    "dot-location": [2, "object"],
    "dot-notation": 2,
    "eqeqeq": [2, "smart"],
    "eol-last": 2,
    "func-names": 2,
    "func-style": [2, "expression"],
    "id-length": [2, { "min": 3, "max": 10, "properties": "never", "exceptions": ["x"] }],
    "id-match": [2, "^[a-z]+([A-Z][a-z]+)*$", { "properties": false }],
    "indent": [2, 2, { "SwitchCase": 1 }],
    "jsx-quotes": [2, "prefer-double"],
    "key-spacing": [2, { "beforeColon": false, "afterColon": true }],
    "linebreak-style": [2, "unix"],
    "lines-around-comment": [2, { "beforeLineComment": true, "afterLineComment": true }],
    "max-depth": [2, 10],
    "max-len": [2, 120, 2,
      { "ignoreComments": true, "ignoreUrls": true, "ignorePattern": "^\\s*var\\s.+=\\s*require\\s*\\(" }
    ],
    "max-nested-callbacks": [2, 3],
    "max-params": [2, 3],
    "max-statements": [2, 4],
    "new-cap": 2,
    "new-parens": 2,
    "newline-after-var": [2, "always"],
    "no-array-constructor": 2,
    "no-bitwise": 2,
    "no-alert": 2,
    "no-class-assign": 2,
    "no-cond-assign": 2,
    "no-console": 1,
    "no-const-assign": 2,
    "no-constant-condition": 2,
    "no-continue": 2,
    "no-dupe-args": 2,
    "no-dupe-keys": 2,
    "no-duplicate-case": 2,
    "no-else-return": 2,
    "no-empty": 2,
    "no-eq-null": 0,
    "no-extra-parens": 2,
    "no-extra-semi": 2,
    "no-floating-decimal": 2,
    "no-func-assign": 2,
    "no-inner-declarations": [2, "both"],
    "no-implicit-coercion": [2, { "boolean": true, "number": true, "string": true }],
    "no-invalid-regexp": 2,
    "no-irregular-whitespace": 2,
    "no-lonely-if": 2,
    "no-inline-comments": 2,
    "no-mixed-spaces-and-tabs": 2,
    "no-multiple-empty-lines": [2, { "max": 2, "maxEOF": 1 }],
    "no-negated-condition": 2,
    "no-nested-ternary": 2,
    "no-new-object": 2,
    "no-obj-calls": 2,
    "no-plusplus": [2, { allowForLoopAfterthoughts: true }],
    "no-restricted-syntax": [2, "FunctionExpression", "WithStatement"],
    "no-spaced-func": 2,
    "no-sparse-arrays": 2,
    "no-ternary": 2,
    "no-this-before-super": 2,
    "no-trailing-spaces": 2,
    "no-unexpected-multiline": 2,
    "no-underscore-dangle": 2,
    "no-unreachable": 2,
    "no-unused-vars": 2,
    "object-curly-spacing": [2, "always"],
    "one-var": [2, "never"],
    "operator-assignment": [2, "never"],
    "operator-linebreak": [2, "none"],
    "padded-blocks": [2, "always"],

    // "prefer-arrow-callback": 2,
    // "prefer-const": 2,
    // "prefer-spread": 2,
    // "prefer-template": 2,

    "quotes": [2, "double", "avoid-escape"],
    "radix": 2,
    "require-jsdoc": [2, {
      "require": {
        "FunctionDeclaration": false,
        "MethodDefinition": false,
        "ClassDeclaration": false
      }
    }],
    "semi-spacing": 2,
    "semi": [2, "always"],
    "sort-vars": 2,
    "space-after-keywords": 2,
    "space-before-blocks": 2,
    "space-before-function-paren": [2, "never"],
    "space-before-keywords": [2, "always"],
    "space-in-parens": [2, "never"],
    "space-infix-ops": 2,
    "space-return-throw-case": 2,
    "space-unary-ops": 2,
    "spaced-comment": [2, "always"],
    "wrap-iife": [2, "outside"],
    "wrap-regex": 2,
    "yoda": 2
  }
};

module.exports = config;
